
@class MatchmakingServer;

@protocol MatchmakingServerDelegate <NSObject>

- (void)matchmakingServer:(MatchmakingServer *)server clientDidConnect:(NSString *)peerID;
- (void)matchmakingServer:(MatchmakingServer *)server clientDidDisconnect:(NSString *)peerID;
- (void)matchmakingServerSessionDidEnd:(MatchmakingServer *)server;
- (void)matchmakingServerNoNetwork:(MatchmakingServer *)server;

@end


@interface MatchmakingServer : NSObject <GKSessionDelegate>

@property (nonatomic, weak) id <MatchmakingServerDelegate> delegate;

@property (nonatomic, assign)           int         maxClients;
@property (nonatomic, strong, readonly) NSArray     *connectedClients;
@property (nonatomic, strong, readonly) GKSession   *session;

- (void)startAcceptingConnectionsForSessionID:(NSString *)sessionID;
- (void)stopAcceptingConnections;
- (void)endSession;

- (NSUInteger)connectedClientCount;
- (NSString *)peerIDForConnectedClientAtIndex:(NSUInteger)index;
- (NSString *)displayNameForPeerID:(NSString *)peerID;

@end


